package edu.gatech.cercs.soa.core.fpq.impl;

import java.io.PrintWriter;
import java.util.*;

import org.xml.sax.Attributes;

import edu.gatech.cercs.soa.core.fpq.IFareClasses;
import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * Describe <code>FareClassesImpl</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class FareClassesImpl implements IFareClasses, XMLable {

    private List<String> fareClasses;
    
    public FareClassesImpl() {
        fareClasses = new ArrayList<String>();
    }
    
    public String[] getFareClasses() {
        return fareClasses.toArray(new String[fareClasses.size()]);
    }

    public void setFareClasses(String[] fcs) {
        fareClasses.clear();
        if (fcs != null) {
            for (int i = 0; i < fcs.length; i++) {
                fareClasses.add(fcs[i]);
            }
        }
    }

    ////////////////////////////////////////////////////////////////////////////
    // XMLable
    
    public void handleXMLCallback(String name, Attributes attrs,
            boolean isBeginElement, Map<String, Object> state) {
        if (isBeginElement) {
        }
        else {
            //Closing Tag
            if (name.equalsIgnoreCase("fareclass")) {
                String str = attrs.getValue("characters");
                if (str != null && str.length() > 0) {
                    fareClasses.add(str);
                }
            }
        }
    }

    public void saveAsXML(PrintWriter writer) {
        StringBuffer sb = new StringBuffer();
        sb.append("<FareClasses>\n");
        for (Iterator<String> iter = fareClasses.iterator(); iter.hasNext();) {
            sb.append("<FareClass>" + iter.next() + "</FareClass>\n");
        }
        sb.append("</FareClasses>\n");
        writer.write(sb.toString());
    }

}
