package edu.gatech.cercs.soa.core.fpr.impl;

import java.io.PrintWriter;
import java.util.Date;
import java.util.Map;

import org.xml.sax.Attributes;

import edu.gatech.cercs.soa.core.DateUtils;
import edu.gatech.cercs.soa.core.fpr.IStopResult;
import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * Describe <code>StopResultImpl</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class StopResultImpl implements IStopResult, XMLable {

    private String airline;
    private Date arrival;
    private Date departure;
    private String destination;
    private String fareClass;
    private String flightNumber;
    private String origin;
    
    public String getAirline() {
        return airline;
    }

    public Date getArrival() {
        return arrival;
    }

    public Date getDeparture() {
        return departure;
    }

    public String getDestination() {
        return destination;
    }

    public String getFareClass() {
        return fareClass;
    }

    public String getFlightNumber() {
        return flightNumber;
    }

    public String getOrigin() {
        return origin;
    }

    public void setAirline(String aln) {
        this.airline = aln;
    }

    public void setArrival(Date arr) {
        this.arrival = arr;
    }

    public void setDeparture(Date dep) {
        this.departure = dep;
    }

    public void setDestination(String dest) {
        this.destination = dest;
    }

    public void setFareClass(String fc) {
        this.fareClass = fc;
    }

    public void setFlightNumber(String fln) {
        this.flightNumber = fln;
    }

    public void setOrigin(String org) {
        this.origin = org;
    }

    ////////////////////////////////////////////////////////////////////////////
    // XMLable
    
    public void handleXMLCallback(String name, Attributes attrs,
            boolean isBeginElement, Map<String, Object> state) {
        if (isBeginElement) {
        }
        else {
            //Closing Tag
            String str = attrs.getValue("characters");
            if (name.equalsIgnoreCase("from")) {
                origin = str;
            }
            else if (name.equalsIgnoreCase("to")) {
                destination = str;
            }
            else if (name.equalsIgnoreCase("departure")) {
                departure = DateUtils.parseDefault(str);
            }
            else if (name.equalsIgnoreCase("arrival")) {
                arrival = DateUtils.parseDefault(str);
            }
            else if (name.equalsIgnoreCase("airline")) {
                airline = str;
            }
            else if (name.equalsIgnoreCase("flightnumber")) {
                flightNumber = str;
            }
            else if (name.equalsIgnoreCase("fareclass")) {
                fareClass = str;
            }
        }
    }

    public void saveAsXML(PrintWriter writer) {
        StringBuffer sb = new StringBuffer();
        sb.append("<Stop>\n");
        sb.append("<From>" + origin + "</From>\n");
        sb.append("<To>" + destination + "</To>\n");
        sb.append("<Departure>" + DateUtils.formatDefault(departure) + "</Departure>\n");
        sb.append("<Arrival>" + DateUtils.formatDefault(arrival) + "</Arrival>\n");
        sb.append("<Airline>" + airline + "</Airline>\n");
        sb.append("<FlightNumber>" + flightNumber + "</FlightNumber>\n");
        sb.append("<FareClass>" + fareClass + "</FareClass>\n");
        sb.append("</Stop>\n");
        writer.write(sb.toString());
    }

}