package edu.gatech.cercs.soa.core.svc;

import java.rmi.Remote;
import java.rmi.RemoteException;


/**
 * The FlightPricingCallbackService is a service endpoint implemented by the
 * clients of GDS.  The GDS uses this service endpoint to return the search
 * results found for the client queries.
 * 
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public interface FlightPricingCallbackService extends Remote {

    /**
     * The updatePrices is invoked by the GDS in response to the 
     * FlightPricingService.searchPrices remote method invocation.
     * 
     * @param fpresult - non-null string in XML format
     * @return String - contains acknowledgement from the client in XML format
     * @throws RemoteException
     */
    public String updatePrices(String fpresult) throws RemoteException;

}
