package edu.gatech.cercs.soa.tws.web;

import java.rmi.RemoteException;

import edu.gatech.cercs.soa.tws.FlightPricingState;


/**
 * Describe <code>TravelWebServiceServlet</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class TravelWebServiceServlet implements TravelWebService {

   /**
    * The searchFlightPrices call submits the query string in XML format for the TWS
    * processing and returns the result immediately.
    * @param query - non-null string in XML format
    * @return String - contains search results in XML format
    * @throws RemoteException
    */
	public String searchFlightPrices(String fpquery) throws RemoteException {
      //TODO
		return fpquery;
	}
	
   /**
    * The updateFlightPrices is invoked by the GDS service and submits the 
    * results of a flight pricing search query in XML format.
    * @param query - non-null string in XML format
    * @return String - contains acknowledgment in XML format
    * @throws RemoteException
    */
   public String updateFlightPrices(String fpresult) throws RemoteException {
      if (fpresult != null) {
         FlightPricingState.getInstance().updateResult(fpresult);
      }
      //TODO - create an acknowledgment message here.
      return fpresult;
   }

}
